//=============================================================================
//  Unified IO - C++ interface for industrial IO cards
//  Copyright (C) 2000, UAB "BBD SOFT" ( http://www.bbdsoft.com/ )
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
//  The author of this program may be contacted at developers@bbdsoft.com
//=============================================================================

#ifndef _BTRACE_
#define _BTRACE_

#ifndef _UNIIO_H
   #include "uniio.h"
#endif

#ifndef _STRING_
   #include <string>
#endif

#ifndef _STDEXCEPT_
   #include <stdexcept>
#endif

#define BFUNCTRACE_ALL()
#define BFUNCTRACE_DEVELOP()
#define BFUNCTRACE_RUNTIME()

#if defined(B_DEVELOP)
  #define BASSERT(test) if(!(test)) { throw std::logic_error ("The following expression must be true: " #test); } else ;
#else
  #define BASSERT(test)
#endif

#if defined(B_DEVELOP)
  #define BASSERTTEXT(test, message) if(!(test)) { std::logic_error exc (message #test); throw exc; } else ;
#else
  #define BASSERTTEXT(test, message)
#endif

namespace Uniio
{

_Export_UNIIO std::string asString (const char * inFormat, ... );

}
#endif